=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

DEBVERS        := $(shell dpkg-parsechangelog | awk '/^Version:/ {print $$2}')
VERSION        := $(shell echo '$(DEBVERS)' | sed -e 's/^[0-9]*://' -e 's/-.*//')

# Fails to build when trying to enhance hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@ --with sphinxdoc --parallel

override_dh_auto_configure:
	cp -v debian/rapmap/RapMap*.h* \
              debian/rapmap/Boo???.hpp \
              debian/rapmap/IndexHeader.hpp \
              debian/rapmap/HitManager.hpp \
              debian/rapmap/JFRaw.hpp \
              debian/rapmap/SA*.hpp \
              debian/rapmap/kseq.h \
              debian/rapmap/SpinLock.hpp \
              debian/rapmap/ScopedTimer.hpp \
              debian/rapmap/bit_*.h \
              debian/rapmap/rank9b.h \
              debian/rapmap/macros.h \
	      debian/rapmap/PairAlignmentFormatter.hpp \
	      debian/rapmap/SingleAlignmentFormatter.hpp \
              include/
	cp -v debian/rapmap/bit_array.c \
              debian/rapmap/rank9b.cpp \
              debian/rapmap/RapMap*.cpp \
	      debian/rapmap/HitManager.cpp \
              src/
	dh_auto_configure

override_dh_auto_build:
	dh_auto_build
	mv doc/source/license.rst doc/ # unused
	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bhtml doc/source doc/build/html
	mv doc/license.rst doc/source/
	cd obj*/src && \
	help2man --no-discard-stderr --no-info --name="highly-accurate, transcript-level quantification estimates from RNA-seq data"\
		./salmon > ../../debian/salmon.1 && \
	for option in index quant swim; do help2man --no-discard-stderr \
		--version-string="${VERSION}" --no-info "./salmon --no-version-check $${option}" \
		--include=../../debian/salmon-$${option}-man-include \
		> ../../debian/salmon-$${option}.1; done

# tests may fail when run out of order or concurrently
override_dh_auto_test:
	DEB_BUILD_OPTIONS="parallel=1" dh_auto_test

override_dh_auto_clean:
	dh_auto_clean
	rm -f include/RapMap*.h* \
	      include/Boo???.hpp \
	      include/IndexHeader.hpp \
	      include/HitManager.hpp \
	      include/JFRaw.hpp \
	      include/SA*.hpp \
	      include/kseq.h \
	      include/bit_*.h \
	      include/rank9b.h \
	      include/macros.h \
	      include/SpinLock.hpp \
	      include/ScopedTimer.hpp \
	      include/PairAlignmentFormatter.hpp \
	      include/SingleAlignmentFormatter.hpp
	rm -f src/bit_array.c \
              src/rank9b.cpp \
	      src/RapMap*.cpp \
	      src/HitManager.cpp
	rm -f debian/*.1
	rm -Rf sample_data
	cd doc && $(MAKE) clean
