=== debian/watch ===
version=3
# Uncomment to find new files on Github
#  - when using releases:
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/salmon-$1\.tar\.gz/,dversionmangle=s/[~\+]ds[0-9]*//,repacksuffix=+ds1,repack,compression=xz \
https://github.com/COMBINE-lab/salmon/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
# Remark: frequently you can do s/#PREFIX#/v?/ since 'v' or nothing is quite common but there are other prefixes possible
