## salmon 0.12.0%2Bds1

=== debian/changelog ===
salmon (0.12.0+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
    Closes: #909767
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * Remove debian/gbp.conf
  * Build-Depends: libbz2-dev, liblzma-dev
  * Use python3-sphinx exclusively
  * Do not parse d/changelog

 -- Andreas Tille <tille@debian.org>  Thu, 13 Dec 2018 18:21:38 +0100

salmon (0.8.0+ds1-1) unstable; urgency=medium

  * Team upload
  * New upstream version
  * debhelper 10
  * d/watch: version=4
  * Update embedded rapmap.

  TODO: Does not build:
  error: no matching function for call to 'create(const char [11], <brace-enclosed initializer list>)'

 -- Andreas Tille <tille@debian.org>  Tue, 24 Jan 2017 14:08:13 +0100
